/**CFile***********************************************************************

  FileName    [cuddMacro.c]

  PackageName [cudd]

  Synopsis    [Functions that used to be macros from cudd.h.]

  Rev 2   Changes include:

              Declarations of functions from cudd.h (which had been macros)
                   Cudd_NotPar
                   Cudd_ComplementPar

******************************************************************************/

#include "cudd.h"


/*---------------------------------------------------------------------------*/
/* Declarations from cudd.h                                                  */
/*---------------------------------------------------------------------------*/

DdNodePar Cudd_NotPar( DdNodePar nodePar )
{
  DdNodePar res;
  res.index=nodePar.index;
  res.address.page = nodePar.address.page;
  res.address.number = -nodePar.address.number;
  return res;
}

DdNodePar Cudd_ComplementPar( DdNodePar nodePar )
{
  DdNodePar res;
  res.index=nodePar.index;
  res.address.page = nodePar.address.page;
  res.address.number = -abs(nodePar.address.number);
  return res;
}






