#include "cuddInt.h"
#include "message.h"

static int cuddFindRefMaster(DdManager *manager);

int cuddReorderMaster(DdManager *manager)
{
  int i;

  cuddReorderInitaite(manager);
  cuddReorderUpdateTableSizes(manager);
  if(manager->gcEnabled)
    cuddUserNodeGarbageCollect(manager);
  cuddFindRefMaster(manager);
  cuddSendExternRef(manager);
  cuddDistributeLevels(manager);
  
  cuddExternGetNewLocations(manager,manager->memory);
  cuddUpdateUserNodes(manager);
  /* NOTE memory cleanup missing */
}

static int cuddFindRefMaster(DdManager *manager)
{
  int i;
  DdNode *node;

  for (i = 0; i < manager->UserNodes.slots; i++) 
    {
      node = manager->UserNodes.nodelist[i];
      while (node!=NULL)
	{
	  cuddIncreaseRefSafe(manager,node->NodePar);
	  node=node->next;
	}
    }

  return(1);
}



