#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "cuddInt.h"
#include "message.h"

extern int debug;
struct timeval start,end,comp={0,0};
struct timezone tzp;
int waiting=0;
FILE *fp;

#define comp_start()  gettimeofday(&start,&tzp) 


void comp_end()
{
  gettimeofday(&end,&tzp);
  comp.tv_sec+=end.tv_sec-start.tv_sec;
  comp.tv_usec+=end.tv_usec-start.tv_usec;
}

/*---------------------------------------------------------------------------*/
/* Definition of internal functions                                          */
/*---------------------------------------------------------------------------*/



void message_handle_loop(manager)
DdManager *manager;
{
  DdNodePar f,g,h;
  int op,index,from;
  DdCallTreeNode caller;
  int done=FALSE;


  int ctr=0;

  /*
  char file[100];
  
  sprintf(file,"/tmp/pvm_proc%x",manager->ProcessInfo->Mytid);
  if ((fp=fopen(file,"w")) == NULL) {
    puts("ERRORRRRR!@@@@@!!!!!!!!!!");
    exit(1);
  }
  */
  while(!done)
    {
      comp_end();
      DdMessagesRecieve(manager);
      comp_start();
      
      /*
      printf("Messages Recieved, flush:%d\n",manager->ProcessInfo->flush);fflush(stdout);
      */

      while(DdWorkQueuePop(manager,&op,&index,&from,&f,&g,&h,&caller)>=0)
	{
	  /*
	  printf("popped %d from %d f.index=%d g.index=%d \n",op,from,f.index,g.index);	  fflush(stdout);
	  */
	  switch(op)
	    {
	    case CUDD_END: 
	      done=TRUE; 
	      comp_end();
	      break; 
	    case CUDD_BDD_AND:
	      cuddBddRecur2(manager,index,f,g,from,caller,op,
			      cuddBddAndBasePar);
	      break;
	    case CUDD_BDD_XOR:
	      cuddBddRecur2(manager,index,f,g,from,caller,op,
			      cuddBddXorBasePar);
	      break;	      
	    case CUDD_BDD_EXISTS_PRE:
	      cuddBddExistAbstractRecurPre(manager,f,g, from, caller);
	      break;		
	    case CUDD_BDD_EXISTS:
	      cuddBddExistAbstractRecur(manager,f,g,from,caller);
	      break;
	    case CUDD_BDD_ITE:
	      cuddBddIteRecurPar(manager,index,f,g,h,from,caller);
	      break;
	    case CUDD_BDD_ANDABSTRACT_PRE:
	      cuddBddAndAbstractRecurPre(manager,f,g,h, from, caller);
	      break;		
	    case CUDD_BDD_ANDABSTRACT:
	      cuddBddAndAbstractRecur(manager,index,f,g,h,from,caller);
	      break;
	    default:
	      assert(0);
	    }
	  if(ctr==1000) {
	    ctr=0;
	    DdReplyRecieve(manager);
	  }
	  else
	    ctr++;
	}
      if(manager->ProcessInfo->flush)
	{
	  /*
	  gettimeofday(&end,&tzp);
	  fprintf(fp,"at %f flush %d total %d, work down %d\n",(float)end.tv_sec+(float)end.tv_usec/1000000,manager->ProcessInfo->flush_count,manager->ProcessInfo->ITE,manager->ProcessInfo->WorkDown);
	  */
	  if(manager->ProcessInfo->down_flag)
	    flush_buffer_down(manager);
	  else
	    {
	      flush_buffer_up(manager);
	      /*
	      manager->ProcessInfo->ITE=0;
	      manager->ProcessInfo->WorkDown=0;
	      */
	      /* decide to resize cache */
	      if (manager->cacheSlots < manager->maxCache &&
		  manager->cacheHits * 100 > manager->cacheLookUps * manager->minHit) {
		ddCacheResizePar(manager);
	      }
	    }

	  manager->ProcessInfo->flush=FALSE;
	}
    }
  /*
   fclose(fp);
   */
}

int ITE[1000];
int Prof[1000];

void main()
{
  DdManager *manager;
  int cache_size,cache_size_max;
  

  manager=cuddInitTablePar(DD_DEFAULT_RESIZE);
  DdInitSlave(manager,&cache_size,&cache_size_max);
  cuddInitCachePar(manager,cache_size,cache_size_max);
  DdWorkQueueCreate(manager);
  DdCallTreeCreate(manager);  

  {
    int i;
    for(i=0;i<1000;i++)
      {
	ITE[i]=0;
	Prof[i]=0;
      }
  }

  printf("mypos: %d\n",manager->Mypos);fflush(stdout);

  comp_start();

  message_handle_loop(manager);

#ifdef DD_COMM_MONITOR
  {
    printf("messages: up %d down %d\n",manager->ProcessInfo->UpMessages,manager->ProcessInfo->DownMessages);
  }
  printf("allocated    %d\n",manager->allocated);
  printf("mem used     %ld\n",manager->memused);
  printf("cacheLookUps %d\n",manager->cacheLookUps);
  printf("cacheHits    %d\n",manager->totCachehits);
  printf("wait         %d\n",waiting);
  printf("forwards     %d\n",manager->ProcessInfo->Forwards);
  printf("ITE          %d\n",manager->ProcessInfo->ITE);
  printf("ITE down     %d\n",manager->ProcessInfo->WorkDown);
  printf("cache collitions %d\n",manager->cachecollisions);
  printf("compute time %f\n",(float)comp.tv_sec+(float)comp.tv_usec/1000000);
  
#endif

  /*
  {
    int i;
    for(i=0;i<manager->size;i++)
      printf("%2d %5d %5d %5d\n",i,ITE[i],manager->memory[i].allocated,Prof[i]);
  }




  {
    int i,index;
    DdNodeOld *page;
    for(index=0;index<manager->size;index++)
      if(cuddLocal(manager,index))
	{
	  printf("index %d level %d keys %d dead %d\n",index,manager->perm[index],manager->subtables[index].keys,manager->subtables[index].dead);
	  page=manager->memory[index].PageTable[0];
	  for(i=1;i<=manager->subtables[index].keys;i++)
	    printf("node:%8d Then:%5d,%8d Else:%5d,%8d\n",i,page[i].type.kids.T.index,page[i].type.kids.T.address.number,page[i].type.kids.E.index,page[i].type.kids.E.address.number);
	}
  }
  */
  pvm_exit();
}


